<template>
	<div class="row">
		<div class="col-2 mb-2">
			<h2 class="text-principal pb-2">DGA</h2>
		</div>
		<div class="col-10 mb-2">
			<div class="row">
				<div class="col-4">
					<button
						v-if="showEnviarLegales"
						@click="devolverALegales(1)"
						type="button"
						class="btn text-start mb-2 pt-1 pb-1 d-inline w-55 mx-2 mt-1"
						:disabled="subirTituloEstadoCumplido"
						:class="{
							'btn-pendiente': subirTituloEstadoPendiente,
							'btn-completo bi-check-lg': subirTituloEstadoCumplido,
						}"
					>
						<i class="bi-arrow-90deg-left"></i> Devolver a Legales
					</button>
				</div>
				<div class="col-4" v-if="form.show_bot_cambios">
					<button
						@click="guardar()"
						type="button"
						class="btn btn-principal mx-2"
						:disabled="!enableComponent"
					>
						GUARDAR CAMBIOS
					</button>
				</div>
				<div class="col-4" v-if="form.show_bot_cambios">
					<button
						@click="cancelar()"
						type="button"
						class="btn btn-principal mx-2"
						:disabled="!enableComponent"
					>
						CANCELAR CAMBIOS
					</button>
				</div>
				<div class="col-4 text-center" v-if="!form.show_bot_cambios">
					<a
						v-if="isTitulo"
						:href="
							getUrl('tituloejecutivoimpdeuda', [
								String(titulo?.id_titulo_ejec),
								String(titulo?.nombre_pdf),
							])
						"
						target="_blank"
						title="Imprimir"
						alt="Imprimir"
						class="btn btn-grey text-light mx-1 p-0 px-2"
						:class="{ disabled: habilitarPDF }"
						:aria-disabled="habilitarPDF"
					>
						<i class="bi bi-printer"></i>
					</a>
				</div>
				<div class="col-4" v-if="!form.show_bot_cambios">
					<BotoneraEscan
						v-if="isTitulo"
						ref="botoneraEscan"
						:titulo="titulo"
						:disabled="!enableComponent"
					/>
				</div>
			</div>
		</div>
		<div class="col-12">
			<div class="row">
				<label for="periodo" class="form-label col-2"
					>Monto total adecuado:</label
				>
				<div class="col-3 mt-3">
					<div class="input-group input-group-sm">
						<span class="input-group-text">$</span>
						<CurrencyInput
							@keyup="showBotCambios"
							v-model="form.total_deuda"
							:options="inputCurrencyOptions"
							class="form-control text-end"
							:disabled="!enableComponent"
						/>
					</div>
				</div>
			</div>
			<div class="row">
				<label for="periodo" class="form-label col-2"
					>Intereses a aplicar:</label
				>
				<div class="col-3 mt-3">
					<div class="input-group input-group-sm">
						<span class="input-group-text">$</span>
						<CurrencyInput
							@keyup="showBotCambios"
							v-model="form.intereses"
							:options="inputCurrencyOptions"
							class="form-control text-end"
							:disabled="!enableComponent"
						/>
					</div>
				</div>
			</div>
			<div class="row mt-3">
				<label for="periodo" class="form-label col-2">TOTAL:</label>
				<div class="col-3 mt-3">
					<div class="input-group input-group-sm">
						<span class="input-group-text">$</span>
						<CurrencyInput
							v-model="form.monto_total"
							:options="inputCurrencyOptions"
							class="form-control text-end"
							:disabled="true"
						/>
					</div>
				</div>
				<div class="col-7 mt-3">
					<button
						v-if="showConfirmDeuda"
						@click="devolverALegales(3, 'Esta acción es irreversible')"
						type="button"
						class="btn text-start mb-2 pt-1 pb-1 d-inline w-70 mx-2 mt-0"
						:disabled="subirTituloEstadoCumplido"
						:class="{
							'btn-pendiente': subirTituloEstadoPendiente,
							'btn-completo bi-check-lg': subirTituloEstadoCumplido,
						}"
					>
						Confirmar Determinación de Deuda
					</button>
				</div>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
// Libraries
import { defineComponent } from "vue";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import CurrencyInput from "./inputs/CurrencyInput.vue";
import { CurrencyDisplay, type CurrencyInputOptions } from "vue-currency-input";
import shared from "@/shared.js";
const { urlApi, getUrl } = shared();

// Stores
import { mapStores, mapState } from "pinia";
import { useTitulosStore } from "@/stores/titulos";
import { useAuxFormDataStore } from "@/stores/auxFormData";

// Components
import BotoneraEscan from "./escaneo/BotoneraEscan.vue";

// Entities
import { Titulo } from "@/entities/Titulo";

export default defineComponent({
	name: "FormularioDga",
	components: {
		BotoneraEscan,
		CurrencyInput,
	},
	props: {
		titulo: {
			type: Titulo,
			required: false,
			default: undefined,
		},
	},
	data() {
		return {
			form: {
				total_deuda: 0 as number,
				intereses: 0 as number,
				monto_total: 0 as number,
				show_bot_cambios: false as boolean,
			},
			inputCurrencyOptions: {
				currency: "ARS",
				hideGroupingSeparatorOnFocus: false,
				currencyDisplay: CurrencyDisplay.hidden,
			} as CurrencyInputOptions,
		};
	},
	computed: {
		...mapState(useAuxFormDataStore, {
			usuarioActualiza: "usuarioActualiza",
		}),
		...mapStores(useTitulosStore),
		isTitulo(): boolean {
			return typeof this.titulo !== "undefined";
		},
		enableComponent(): boolean {
			if (
				typeof this.titulo !== "undefined" &&
				typeof this.usuarioActualiza !== "undefined"
			) {
				return (
					this.usuarioActualiza.esDGA() &&
					this.titulo.id_estado.toString() == "2"
				);
			}
			return true;
		},
		habilitarPDF(): boolean {
			return !(typeof this.titulo !== "undefined" && this.enableComponent);
		},
		showEnviarLegales(): boolean {
			if (
				typeof this.titulo !== "undefined" &&
				typeof this.usuarioActualiza !== "undefined"
			) {
				return (
					this.usuarioActualiza.esDGA() &&
					Number(this.titulo.id_estado) < 3 &&
					Number(this.titulo.id_estado) > 1
				);
			}
			return false;
		},
		showConfirmDeuda(): boolean {
			return (
				this.showEnviarLegales &&
				// Se comento esta validación hasta en tanto la oficina de DGA consiga un escaner
				// this.titulo?.id_rel_tabla_reg !== null &&
				// this.titulo?.id_rel_tabla_reg !== undefined &&
				this.form.monto_total > 0 &&
				!this.form.show_bot_cambios
			);
		},
		subirTituloEstadoCumplido(): boolean {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) > 3;
			}
			return false;
		},
		subirTituloEstadoPendiente(): boolean {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) <= 3;
			}
			return false;
		},
		total(): number {
			return this.form.total_deuda + this.form.intereses;
		},
	},
	mounted() {},
	methods: {
		async guardar() {
			try {
				await http.post(urlApi + "edicionTitulo", {
					accion: "G",
					id_titulo_ejec: this.titulo?.id_titulo_ejec,
					total_deuda: this.form.total_deuda,
					intereses: this.form.intereses,
					monto_total: this.form.monto_total,
				});
				// this.initForm();
				// this.$emit("updateTitulosList", this.titulo?.id_titulo_ejec);
				this.form.show_bot_cambios = false;
				Swal.fire({
					icon: "success",
					text: "Actualización exitosa",
				});
			} catch (error: any) {
				Swal.fire({
					icon: "error",
					text: error.response.data.res.mensaje,
				});
			}
		},
		async cancelar() {
			const titulo = await this.titulosStore.findTituloById(
				this.titulo?.id_titulo_ejec!
			);
			this.form.total_deuda = Number(titulo?.total_deuda!);
			this.form.intereses = Number(titulo?.intereses!);
			this.form.monto_total = Number(titulo?.monto_total!);
			this.form.show_bot_cambios = false;
		},
		initForm() {
			this.form.total_deuda = 0;
			this.form.intereses = 0;
			this.form.monto_total = 0;
			this.form.show_bot_cambios = false;
		},
		showBotCambios() {
			this.form.show_bot_cambios = true;
		},
		getUrl(path: string, params: string[] = []): string {
			return getUrl(path, params);
		},
		devolverALegales(estado: number = 3, text: string = "") {
			Swal.fire({
				title: "¿ Esta seguro de devolverlo a Legales ?",
				text: text,
				icon: "warning",
				showCancelButton: true,
				confirmButtonColor: "#3085d6",
				cancelButtonColor: "#d33",
				confirmButtonText: "Confirmar",
			}).then(async (result) => {
				if (result.isConfirmed) {
					var rta: boolean = await this.titulosStore.cambiarEstadoTitulo(
						this.titulo,
						estado
					);
					if (rta) {
						this.$emit("updateTitulosList");
						Swal.fire({
							icon: "success",
							text: "Se devolvió correctamente el título a Legales.",
						}).then(() => {
							this.$router.push({ name: "listado" });
						});
					} else {
						Swal.fire({
							icon: "error",
							text: "Ocurrio un error, pruebe intentar nuevamente.",
						});
					}
				}
			});
		},
	},
	watch: {
		titulo() {
			if (typeof this.titulo !== "undefined") {
				this.form.total_deuda =
					this.titulo.total_deuda != null ? Number(this.titulo.total_deuda) : 0;
				this.form.intereses =
					this.titulo.intereses != null ? Number(this.titulo.intereses) : 0;
			}
		},
		total(newValue: number) {
			this.form.monto_total = newValue;
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
